<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <meta name="revisit-after" content="7 days" />
        <link rel="shortcut icon" href="{$site_url}favicon.ico" />
        {if $css}
        {foreach $css as $element}
        <link rel="stylesheet" href="{$element}" type="text/css" />
        {/foreach}
        {/if}
        {if $css_additional}
        {foreach $css_additional as $element}
        <link rel="stylesheet" href="{$element}" type="text/css" />
        {/foreach}
        {/if}
        {if $js}
        {foreach $js as $element}
        <script src="{$element}" type="text/javascript"></script>
        {/foreach}
        {/if}
        {if $js_additional}
        {foreach $js_additional as $element}
        <script src="{$element}" type="text/javascript"></script>
        {/foreach}
        {/if}
        <!-- Mobile Specific Metas -->
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <!-- Le styles -->
        <!-- Use new way for google web fonts
        http://www.smashingmagazine.com/2012/07/11/avoiding-faux-weights-styles-google-web-fonts -->
        <link href='http://fonts.googleapis.com/css?family=Open+Sans:400,700' rel='stylesheet' type='text/css' /> <!-- Headings -->
        <link href='http://fonts.googleapis.com/css?family=Droid+Sans:400,700' rel='stylesheet' type='text/css' /> <!-- Text -->
        <!--[if lt IE 9]>
        <link href="http://fonts.googleapis.com/css?family=Open+Sans:400" rel="stylesheet" type="text/css" />
        <link href="http://fonts.googleapis.com/css?family=Open+Sans:700" rel="stylesheet" type="text/css" />
        <link href="http://fonts.googleapis.com/css?family=Droid+Sans:400" rel="stylesheet" type="text/css" />
        <link href="http://fonts.googleapis.com/css?family=Droid+Sans:700" rel="stylesheet" type="text/css" />
        <![endif]-->
        <link rel="apple-touch-icon-precomposed" sizes="144x144" href="{$site_url}uploads/modules/main/admin/images/apple-touch-icon-144-precomposed.png" />
        <link rel="apple-touch-icon-precomposed" sizes="114x114" href="{$site_url}uploads/modules/main/admin/images/apple-touch-icon-114-precomposed.png" />
        <link rel="apple-touch-icon-precomposed" sizes="72x72" href="{$site_url}uploads/modules/main/admin/images/apple-touch-icon-72-precomposed.png" />
        <link rel="apple-touch-icon-precomposed" href="{$site_url}uploads/modules/main/admin/images/apple-touch-icon-57-precomposed.png" />
        <!-- Le HTML5 shim, for IE6-8 support of HTML5 elements -->
        <!--[if lt IE 9]>
        <script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
        <![endif]-->
        {helper func_name=show_seo helper_name=seo func_param=$seo_data}
        <script type="text/javascript">
            //adding load class to body and hide page
            document.documentElement.className += 'loadstate';
        </script>
    </head>
    <body class="errorPage">

        <div class="container-fluid">

            <div class="errorContainer">
                <div class="page-header">
                    <h2 class="center">{$heading}</h2>
                </div>

                <h2 class="center">{$message}</h2>

                <div class="center">
                    <a href="javascript: history.go(-1)" class="btn" style="margin-right:10px;"><span class="icon16 typ-icon-back"></span>{l('button_go_back','errors')}</a>
                    <a href="{$site_url}{$lang_code_prefix}admin" class="btn"><span class="icon16 icomoon-icon-home"></span>{l('button_main','errors')}</a>
                </div>

            </div>

        </div><!-- End .container-fluid -->

        <!-- Le javascript
        ================================================== -->

        <script type="text/javascript">
            {literal}
            // document ready function
            $(document).ready(function() {
                //------------- Some fancy stuff in error pages -------------//
                $('.errorContainer').hide();
                $('.errorContainer').fadeIn(1000).animate({
                    'top': "50%", 'margin-top': +($('.errorContainer').height()/-2-30)
                }, {duration: 750, queue: false}, function() {
                    // Animation complete.
                });
                $("html").removeClass("loadstate");
            });
            {/literal}
        </script>

    </body>
</html>
