<?php

class Install_model extends CI_Model {

    public $CI;
    public $install_url = false;
    private $connection_id;
    
    private $module_version = 3;
    private $sub_version = 1;
    private $patch_version = 0;
    private $name = 'Updates module';
    private $module_type = 'mandatory_product';
    private $keyword = 'install';
    
    public function __construct() {
        parent::__construct();
        $this->CI = & get_instance();
    }

    public function install() {
        $this->CI->load->helper('Modules');
        if (function_exists('get_module_by_keyword')) {
            $module = get_module_by_keyword($this->keyword);
            if ($module) {
                $module->module_version = $this->module_version;
                $module->sub_version = $this->sub_version;
                $module->patch_version = $this->patch_version;
                
            } else {
                $module = array(
                    'keyword' => $this->keyword,
                    'name' => $this->name,
                    'module_type' => $this->module_type,
                    'module_version' => $this->module_version,
                    'sub_version' => $this->sub_version,
                    'patch_version' => $this->patch_version,
                );
            }
            if (function_exists('save_module')) {
                save_module($module);
            }
        }
    }

    public function update($module_version = 0, $sub_version = 0, $patch_version) {
        $this->CI->load->helper('Modules');
        if (function_exists('get_module_by_keyword')) {
            $module = get_module_by_keyword($this->keyword);
            if ($module) {
                $module->module_version = $this->module_version;
                $module->sub_version = $this->sub_version;
                $module->patch_version = $this->patch_version;
                
            } else {
                $module = array(
                    'keyword' => $this->keyword,
                    'name' => $this->name,
                    'module_type' => $this->module_type,
                    'module_version' => $this->module_version,
                    'sub_version' => $this->sub_version,
                    'patch_version' => $this->patch_version,
                );
            }
            if (function_exists('save_module')) {
                save_module($module);
            }
        }
    }

    function is_file_writable($file = '', $mode = 0777) {
        @chmod($file, $mode);
        clearstatcache();
        if (!is_writable($file)) {
            if (!$this->connection_id) {
                $this->CI->config->load('ftp', true);
                $ftp_settings = $this->CI->config->item('ftp');
                $ftp_host = '';
                $ftp_user = '';
                $ftp_pass = '';
                if (isset($ftp_settings['hostname'])) {
                    $ftp_host = $ftp_settings['hostname'];
                }
                if (isset($ftp_settings['username'])) {
                    $ftp_user = $ftp_settings['username'];
                }
                if (isset($ftp_settings['password'])) {
                    $ftp_pass = $ftp_settings['password'];
                }
                if ($ftp_host && $ftp_user && $ftp_pass) {
                    $this->connection_id = @ftp_connect($ftp_host);
                    $login_result = false;
                    if ($this->connection_id) {
                        @ftp_login($this->connection_id, $ftp_user, $ftp_pass);
                    }
                }
            }
            @ftp_chmod($this->connection_id, $mode, $file);
        }
        @ftp_close($this->connection_id);
        return is_writable($file);
    }

}
