<?php

class Main_install_model extends N_Model {

    private $CI;
    private $module_version = 3;
    private $sub_version = 2;
    private $patch_version = 11;
    private $keyword = 'main';
    private $name = 'General module';
    private $module_type = 'mandatory_product';
    protected $dynamic_blocks_areas = array(
        0 => array(
            'keyword' => 'index_page',
            'name' => 'Index page',
            'status' => 1
        )
    );
    protected $dynamic_blocks = array(
        0 => array(
            'keyword' => 'main_promo_block',
            'name' => 'Promo content',
            'module' => 'main',
            'model' => 'Main_model',
            'method' => '_dynamic_block_get_main_promo',
            'params' => '',
            'views' => 'a:1:{i:0;s:7:"default";}',
            'area' => array(
                'keyword' => 'index_page',
                'params' => '',
                'view_string' => 'default',
                'cache_time' => '600'
            )
        )
    );

    public function __construct() {
        parent::__construct();
        $this->CI = get_instance();
    }

    public function install() {
        $this->load->database();
        $this->load->dbforge();
        $this->CI->load->helper('Options');
        $orig_languages = false;
        if (function_exists('load_options')) {
            $orig_languages = load_options('languages');
        }
        $sessions_fields = array(
            'session_id' => array(
                'type' => 'VARCHAR',
                'constraint' => 40,
                'default' => '0',
                'null' => TRUE
            ),
            'ip_address' => array(
                'type' => 'VARCHAR',
                'constraint' => '45',
                'default' => '0',
                'null' => TRUE
            ),
            'user_agent' => array(
                'type' => 'VARCHAR',
                'constraint' => '50',
                'default' => '',
                'null' => TRUE
            ),
            'last_activity' => array(
                'type' => 'INT',
                'constraint' => '11',
                'unsigned' => TRUE,
                'default' => '0',
                'null' => TRUE
            ),
            'user_data' => array(
                'type' => 'TEXT',
                'default' => '',
                'null' => TRUE
            )
        );
        $this->create_table('sessions', $sessions_fields, array(
            'session_id'
        ));
        $fields = array(
            'id' => array(
                'type' => 'INT',
                'constraint' => '11',
                'null' => FALSE,
                'auto_increment' => TRUE
            ),
            'service_prefix' => array(
                'type' => 'VARCHAR',
                'constraint' => '255',
                'default' => '',
                'null' => TRUE
            ),
            'name' => array(
                'type' => 'VARCHAR',
                'constraint' => '255',
                'default' => '',
                'null' => TRUE
            ),
            'russian' => array(
                'type' => 'LONGTEXT',
                'default' => '',
                'null' => TRUE
            ),
            'english' => array(
                'type' => 'LONGTEXT',
                'default' => '',
                'null' => TRUE
            ),
            'date_created' => array(
                'type' => 'INT',
                'constraint' => '11',
                'default' => '0',
                'null' => TRUE
            ),
            'date_modified' => array(
                'type' => 'INT',
                'constraint' => '11',
                'default' => '0',
                'null' => TRUE
            ),
            'status' => array(
                'type' => 'TINYINT',
                'constraint' => '1',
                'default' => '0',
                'null' => TRUE
            ),
            'full' => array(
                'type' => 'TINYINT',
                'constraint' => '1',
                'default' => '0',
                'null' => TRUE
            ),
            'wrapper' => array(
                'type' => 'TINYINT',
                'constraint' => '1',
                'default' => '1',
                'null' => TRUE
            ),
            'smarty' => array(
                'type' => 'TINYINT',
                'constraint' => '1',
                'default' => '0',
                'null' => TRUE
            ),
            'wisywig' => array(
                'type' => 'TINYINT',
                'constraint' => '1',
                'default' => '0',
                'null' => TRUE
            )
        );
        if (is_array($orig_languages) && count($orig_languages) > 0) {
            foreach ($orig_languages as $language) {
                $fields [$language] = array(
                    'type' => 'LONGTEXT',
                    'default' => '',
                    'null' => TRUE
                );
            }
        }
        $this->create_table('main_pages', $fields, array(
            'id'
        ));
        $fields = array(
            'id' => array(
                'type' => 'INT',
                'constraint' => '11',
                'null' => FALSE,
                'auto_increment' => TRUE
            ),
            'page_id' => array(
                'type' => 'INT',
                'constraint' => '11',
                'default' => '0',
                'null' => TRUE
            ),
            'file' => array(
                'type' => 'VARCHAR',
                'constraint' => '255',
                'default' => '',
                'null' => TRUE
            ),
            'date_created' => array(
                'type' => 'INT',
                'constraint' => '11',
                'default' => '0',
                'null' => TRUE
            ),
            'date_modified' => array(
                'type' => 'INT',
                'constraint' => '11',
                'default' => '0',
                'null' => TRUE
            )
        );
        $this->create_table('main_pages_files', $fields, array(
            'id'
        ));
        $fields = array(
            'id' => array(
                'type' => 'INT',
                'constraint' => '11',
                'null' => FALSE,
                'auto_increment' => TRUE
            ),
            'service_prefix' => array(
                'type' => 'VARCHAR',
                'constraint' => '255',
                'default' => '',
                'null' => TRUE
            ),
            'russian' => array(
                'type' => 'VARCHAR',
                'constraint' => '255',
                'null' => TRUE
            ),
            'english' => array(
                'type' => 'VARCHAR',
                'constraint' => '255',
                'null' => TRUE
            ),
            'link' => array(
                'type' => 'TEXT'
            ),
            'color' => array(
                'type' => 'VARCHAR',
                'constraint' => '255'
            ),
            'item_id' => array(
                'type' => 'INT',
                'constraint' => '11',
                'null' => FALSE
            ),
            'item_type' => array(
                'type' => 'VARCHAR',
                'constraint' => '255'
            ),
            'animation' => array(
                'type' => 'TINYINT',
                'constraint' => '1'
            ),
            'image_1' => array(
                'type' => 'TEXT'
            ),
            'image_2' => array(
                'type' => 'TEXT'
            ),
            'status' => array(
                'type' => 'TINYINT',
                'constraint' => '1'
            ),
            'date_created' => array(
                'type' => 'INT',
                'constraint' => '11',
                'null' => FALSE
            ),
            'date_modified' => array(
                'type' => 'INT',
                'constraint' => '11',
                'null' => FALSE
            )
        );
        if (is_array($orig_languages) && count($orig_languages) > 0) {
            foreach ($orig_languages as $language) {
                $fields [$language] = array(
                    'type' => 'VARCHAR',
                    'constraint' => '255',
                    'null' => TRUE
                );
            }
        }
        $this->create_table('main_slider_metro_blocks', $fields, array(
            'id'
        ));
        $fields = array(
            'id' => array(
                'type' => 'INT',
                'constraint' => '11',
                'null' => FALSE,
                'auto_increment' => TRUE
            ),
            'service_prefix' => array(
                'type' => 'VARCHAR',
                'constraint' => '255',
                'default' => '',
                'null' => TRUE
            ),
            'item_id' => array(
                'type' => 'INT',
                'constraint' => '11'
            ),
            'file' => array(
                'type' => 'TEXT',
                'default' => '',
                'null' => TRUE
            ),
            'english' => array(
                'type' => 'LONGTEXT',
                'default' => '',
                'null' => TRUE
            ),
            'russian' => array(
                'type' => 'LONGTEXT',
                'default' => '',
                'null' => TRUE
            ),
            'status' => array(
                'type' => 'TINYINT',
                'constraint' => '1'
            ),
            'date_created' => array(
                'type' => 'INT',
                'constraint' => '11',
                'null' => FALSE
            ),
            'date_modified' => array(
                'type' => 'INT',
                'constraint' => '11',
                'null' => FALSE
            ),
            'smarty' => array(
                'type' => 'TINYINT',
                'constraint' => '1',
                'default' => '0',
                'null' => TRUE
            )
        );
        if (is_array($orig_languages) && count($orig_languages) > 0) {
            foreach ($orig_languages as $language) {
                $fields [$language] = array(
                    'type' => 'LONGTEXT',
                    'default' => '',
                    'null' => TRUE
                );
            }
        }
        $this->create_table('main_slider_images', $fields, array(
            'id'
        ));
        $pages = array();
        if (file_exists(MODULESPATH . 'main/install/pages.php'))
            @include_once (MODULESPATH . 'main/install/pages.php');
        foreach ($pages as $value) {
            $this->db->delete('main_pages', array(
                'name' => $value ['name']
            ));
            $this->db->insert('main_pages', $value);
        }
        if ($this->db->table_exists('monetization_services')) {
            $this->install_monetization();
        }
        $this->CI->load->helper('Modules');
        if (function_exists('get_module_by_keyword')) {
            $module = get_module_by_keyword($this->keyword);
            if ($module) {
                $module->module_version = $this->module_version;
                $module->sub_version = $this->sub_version;
                $module->patch_version = $this->patch_version;
            } else {
                $module = array(
                    'keyword' => $this->keyword,
                    'name' => $this->name,
                    'module_type' => $this->module_type,
                    'module_version' => $this->module_version,
                    'sub_version' => $this->sub_version,
                    'patch_version' => $this->patch_version
                );
            }
            if (function_exists('save_module')) {
                save_module($module);
            }
        }
        $this->db->cache_delete_prefix('sessions');
        $this->db->cache_delete_prefix('main_pages');
        $this->db->cache_delete_prefix('main_pages_files');
        $this->db->cache_delete_prefix('main_slider_metro_blocks');
        $this->db->cache_delete_prefix('main_slider_images');
        $this->load->helper('Banners');
        if ($this->db->table_exists('banners') && $this->db->table_exists('themes')) {
            $this->install_banners();
        }
    }

    public function update($module_version = 0, $sub_version = 0, $patch_version = 0) {
        $this->CI->load->helper('Options');
        $orig_languages = false;
        if (function_exists('load_options')) {
            $orig_languages = load_options('languages');
        }
        if (!$orig_languages || !is_array($orig_languages)) {
            $orig_languages = array(
                'en' => 'english'
            );
        }
        $russian_exists = true;
        if ($this->db->table_exists('languages') && !$this->db->field_exists('russian', 'languages')) {
            $russian_exists = false;
        }
        switch ($sub_version) {
            case 1 :
                $fields = array(
                    'service_prefix' => array(
                        'type' => 'VARCHAR',
                        'constraint' => '255',
                        'default' => '',
                        'null' => TRUE
                    )
                );
                $this->create_table('main_pages', $fields, null, true);
                $fields = array(
                    'id' => array(
                        'type' => 'INT',
                        'constraint' => '11',
                        'null' => FALSE,
                        'auto_increment' => TRUE
                    ),
                    'service_prefix' => array(
                        'type' => 'VARCHAR',
                        'constraint' => '255',
                        'default' => '',
                        'null' => TRUE
                    ),
                    'russian' => array(
                        'type' => 'VARCHAR',
                        'constraint' => '255'
                    ),
                    'english' => array(
                        'type' => 'VARCHAR',
                        'constraint' => '255'
                    ),
                    'link' => array(
                        'type' => 'TEXT'
                    ),
                    'color' => array(
                        'type' => 'VARCHAR',
                        'constraint' => '255'
                    ),
                    'item_id' => array(
                        'type' => 'INT',
                        'constraint' => '11',
                        'null' => FALSE
                    ),
                    'item_type' => array(
                        'type' => 'VARCHAR',
                        'constraint' => '255'
                    ),
                    'animation' => array(
                        'type' => 'TINYINT',
                        'constraint' => '1'
                    ),
                    'image_1' => array(
                        'type' => 'TEXT'
                    ),
                    'image_2' => array(
                        'type' => 'TEXT'
                    ),
                    'status' => array(
                        'type' => 'TINYINT',
                        'constraint' => '1'
                    ),
                    'date_created' => array(
                        'type' => 'INT',
                        'constraint' => '11',
                        'null' => FALSE
                    ),
                    'date_modified' => array(
                        'type' => 'INT',
                        'constraint' => '11',
                        'null' => FALSE
                    )
                );
                if (!$russian_exists) {
                    unset($fields ['russian']);
                }
                foreach ($orig_languages as $lang_id => $lang_value) {
                    if (!isset($fields [$lang_value])) {
                        $fields [$lang_value] = $fields ['english'];
                    }
                }
                $this->create_table('main_slider_metro_blocks', $fields, array(
                    'id'
                ));
                $fields = array(
                    'id' => array(
                        'type' => 'INT',
                        'constraint' => '11',
                        'null' => FALSE,
                        'auto_increment' => TRUE
                    ),
                    'service_prefix' => array(
                        'type' => 'VARCHAR',
                        'constraint' => '255',
                        'default' => '',
                        'null' => TRUE
                    ),
                    'item_id' => array(
                        'type' => 'INT',
                        'constraint' => '11'
                    ),
                    'file' => array(
                        'type' => 'TEXT',
                        'default' => '',
                        'null' => TRUE
                    ),
                    'english' => array(
                        'type' => 'LONGTEXT'
                    ),
                    'russian' => array(
                        'type' => 'LONGTEXT',
                        'default' => '',
                        'null' => TRUE
                    ),
                    'status' => array(
                        'type' => 'TINYINT',
                        'constraint' => '1'
                    ),
                    'date_created' => array(
                        'type' => 'INT',
                        'constraint' => '11',
                        'null' => FALSE
                    ),
                    'date_modified' => array(
                        'type' => 'INT',
                        'constraint' => '11',
                        'null' => FALSE
                    )
                );
                if (!$russian_exists) {
                    unset($fields ['russian']);
                }
                foreach ($orig_languages as $lang_id => $lang_value) {
                    if (!isset($fields [$lang_value])) {
                        $fields [$lang_value] = $fields ['english'];
                    }
                }
                $this->create_table('main_slider_images', $fields, array(
                    'id'
                ));
                $this->load->library('session');
                $contents = array(
                    array(
                        'name' => 'contact_types',
                        'data' => $this->CI->session->_serialize(array(
                            'email',
                            'address',
                            'phone',
                            'skype',
                            'icq'
                        ))
                    ),
                    array(
                        'name' => 'find_us_link_types',
                        'data' => $this->CI->session->_serialize(array(
                            'facebook',
                            'google',
                            'vkontakte',
                            'twitter'
                        ))
                    ),
                    array(
                        'name' => 'main_slider',
                        'data' => $this->CI->session->_serialize(array(
                            'status' => 1,
                            'mode' => 'images'
                        ))
                    ),
                    array(
                        'name' => 'metro_mode_text',
                        'data' => $this->CI->session->_serialize(array(
                            'russian' => '',
                            'english' => ''
                        ))
                    )
                );
                foreach ($contents as $content) {
                    $this->db->delete('options', array(
                        'name' => $content ['name']
                    ));
                    $this->db->insert('options', $content);
                }
                $this->db->cache_delete_prefix('options');
                $this->_install_languages('3_2_0');
            case 2 :
                switch ($patch_version) {
                    case 0 :
                        $this->_install_languages('3_2_1');
                    case 1 :
                        $this->_install_languages('3_2_2');
                        $fields = array(
                            'smarty' => array(
                                'type' => 'TINYINT',
                                'constraint' => '1',
                                'default' => '0',
                                'null' => TRUE
                            )
                        );
                        $this->create_table('main_pages', $fields, null, true);
                        $this->create_table('main_slider_images', $fields, null, true);
                    case 2 :
                        $this->_install_languages('3_2_3');
                        $fields = array(
                            'wisywig' => array(
                                'type' => 'TINYINT',
                                'constraint' => '1',
                                'default' => '0',
                                'null' => TRUE
                            )
                        );
                        $this->create_table('main_pages', $fields, null, true);
                    case 3 :
                        $this->_install_languages('3_2_4');
                        $fields = array(
                            'wrapper' => array(
                                'type' => 'TINYINT',
                                'constraint' => '1',
                                'default' => '1',
                                'null' => TRUE
                            )
                        );
                        $this->create_table('main_pages', $fields, null, true);
                        $this->load->helper('Services');
                        if (function_exists('get_template_by_gid')) {
                            $combined_template = get_template_by_gid('combined_template');
                            if ($combined_template) {
                                $combined_template = (array) $combined_template;
                                if (is_string($combined_template ['admin_data'])) {
                                    $combined_template ['admin_data'] = @unserialize($combined_template ['admin_data']);
                                }
                                $combined_template ['admin_data'] ['email_triggers_count'] = 'int';
                                $combined_template ['admin_data'] = @serialize($combined_template ['admin_data']);
                                unset($combined_template ['admin_data_array']);
                                unset($combined_template ['name']);
                                save_services_template($combined_template);
                            }
                        }
                        $languages = array();
                        if (file_exists(MODULESPATH . 'main/install/services_languages_3_2_4.php'))
                            @include_once (MODULESPATH . 'main/install/services_languages_3_2_4.php');
                        foreach ($languages as $language) {
                            $this->db->delete('languages', array(
                                'key' => $language ['key'],
                                'module' => $language ['module']
                            ));
                            $language ['default'] = 1;
                            if (!$russian_exists) {
                                unset($language ['russian']);
                            }
                            foreach ($orig_languages as $lang_id => $lang_value) {
                                if (!isset($language [$lang_value])) {
                                    $language [$lang_value] = $language ['english'];
                                }
                            }
                            $this->db->insert('languages', $language);
                        }
                        $this->db->cache_delete_prefix('languages');
                    case 4 :
                        $this->_install_languages('3_2_5');
                        $this->load->helper('Services');
                        if (function_exists('get_template_by_gid')) {
                            $combined_template = get_template_by_gid('combined_template');
                            if ($combined_template) {
                                $combined_template = (array) $combined_template;
                                if (is_string($combined_template ['admin_data'])) {
                                    $combined_template ['admin_data'] = @unserialize($combined_template ['admin_data']);
                                }
                                $combined_template ['admin_data'] ['email_autoresponders_count'] = 'int';
                                $combined_template ['admin_data'] = @serialize($combined_template ['admin_data']);
                                unset($combined_template ['admin_data_array']);
                                unset($combined_template ['name']);
                                save_services_template($combined_template);
                            }
                        }
                        $languages = array();
                        if (file_exists(MODULESPATH . 'main/install/services_languages_3_2_5.php'))
                            @include_once (MODULESPATH . 'main/install/services_languages_3_2_5.php');
                        foreach ($languages as $language) {
                            $this->db->delete('languages', array(
                                'key' => $language ['key'],
                                'module' => $language ['module']
                            ));
                            $language ['default'] = 1;
                            if (!$russian_exists) {
                                unset($language ['russian']);
                            }
                            foreach ($orig_languages as $lang_id => $lang_value) {
                                if (!isset($language [$lang_value])) {
                                    $language [$lang_value] = $language ['english'];
                                }
                            }
                            $this->db->insert('languages', $language);
                        }
                        $this->db->cache_delete_prefix('languages');
                    case 5 :
                    case 6 :
                    case 7 :
                        $this->_install_languages('3_2_8');
                    case 8 :
                        $this->load->helper('Dynamic_blocks');
                        if (function_exists('get_dynamic_block_by_id') && $this->db->table_exists('dynamic_blocks')) {
                            $this->install_dynamic_blocks();
                        }
                    case 9 :
                        $this->_install_languages('3_2_10');
                }
        }
        $this->CI->load->helper('Modules');
        if (function_exists('get_module_by_keyword')) {
            $module = get_module_by_keyword($this->keyword);
            if ($module) {
                $module->module_version = $this->module_version;
                $module->sub_version = $this->sub_version;
                $module->patch_version = $this->patch_version;
            } else {
                $module = array(
                    'keyword' => $this->keyword,
                    'name' => $this->name,
                    'module_type' => $this->module_type,
                    'module_version' => $this->module_version,
                    'sub_version' => $this->sub_version,
                    'patch_version' => $this->patch_version
                );
            }
            if (function_exists('save_module')) {
                save_module($module);
            }
        }
        $this->db->cache_delete_prefix('sessions');
        $this->db->cache_delete_prefix('main_pages');
        $this->db->cache_delete_prefix('main_pages_files');
        $this->db->cache_delete_prefix('main_slider_metro_blocks');
        $this->db->cache_delete_prefix('main_slider_images');
    }

    public function install_options() {
        $this->load->library('session');
        $contents = array(
            array(
                'name' => 'languages',
                'data' => $this->CI->session->_serialize(array(
                    'ru' => 'russian',
                    'en' => 'english'
                ))
            ),
            array(
                'name' => 'languages_statuses',
                'data' => $this->CI->session->_serialize(array(
                    'russian' => 1,
                    'english' => 1
                ))
            ),
            array(
                'name' => 'contact_info',
                'data' => $this->CI->session->_serialize(array(
                    array(
                        'type' => 'email',
                        'text' => 'contact@psoftware.net'
                    ),
                    array(
                        'type' => 'address',
                        'text' => 'Russia, Mari El Respublic, Youshkar-Ola City'
                    ),
                    array(
                        'type' => 'phone',
                        'text' => '+1234567890'
                    )
                ))
            ),
            array(
                'name' => 'additional_contact',
                'data' => $this->CI->session->_serialize(array(
                    array(
                        'type' => 'skype',
                        'text' => '1234567890'
                    ),
                    array(
                        'type' => 'icq',
                        'text' => '1234567890'
                    )
                ))
            ),
            array(
                'name' => 'contact_types',
                'data' => $this->CI->session->_serialize(array(
                    'email',
                    'address',
                    'phone',
                    'skype',
                    'icq'
                ))
            ),
            array(
                'name' => 'find_us_links',
                'data' => $this->CI->session->_serialize(array(
                    array(
                        'type' => 'facebook',
                        'link' => ''
                    ),
                    array(
                        'type' => 'flickr',
                        'link' => ''
                    ),
                    array(
                        'type' => 'googleplus',
                        'link' => ''
                    ),
                    array(
                        'type' => 'instagram',
                        'link' => ''
                    ),
                    array(
                        'type' => 'linkedin',
                        'link' => ''
                    ),
                    array(
                        'type' => 'pinterest',
                        'link' => ''
                    ),
                    array(
                        'type' => 'twitter',
                        'link' => ''
                    ),
                    array(
                        'type' => 'vkontakte',
                        'link' => ''
                    )
                ))
            ),
            array(
                'name' => 'find_us_link_types',
                'data' => $this->CI->session->_serialize(array(
                    'facebook',
                    'flickr',
                    'googleplus',
                    'instagram',
                    'linkedin',
                    'pinterest',
                    'twitter',
                    'vkontakte'
                ))
            ),
            array(
                'name' => 'google_search_widget',
                'data' => $this->CI->session->_serialize('')
            ),
            array(
                'name' => 'google_analytics_widget',
                'data' => $this->CI->session->_serialize('')
            ),
            array(
                'name' => 'yandex_metrika_widget',
                'data' => $this->CI->session->_serialize('')
            )
        );
        if (is_array($contents) && count($contents) > 0) {
            foreach ($contents as $content) {
                $this->db->delete('options', array(
                    'name' => $content ['name']
                ));
                $this->db->insert('options', $content);
            }
        }
        $contents = array();
        if (file_exists(MODULESPATH . 'main/install/options.php'))
            @include_once (MODULESPATH . 'main/install/options.php');
        if (is_array($contents) && count($contents) > 0) {
            foreach ($contents as $content) {
                $this->db->delete('options', array(
                    'name' => $content ['name']
                ));
                $this->db->insert('options', $content);
            }
        }
        $this->db->cache_delete_prefix('options');
    }

    public function install_seo() {
        $seo = array();
        $this->CI->load->helper('Options');
        $orig_languages = false;
        if (function_exists('load_options')) {
            $orig_languages = load_options('languages');
        }
        if (!$orig_languages) {
            $orig_languages = array(
                'en' => 'english'
            );
        }
        $russian_exists = true;
        if (!$this->db->field_exists('russian', 'seo')) {
            $russian_exists = false;
        }
        if (file_exists(MODULESPATH . 'main/install/seo.php'))
            @include_once (MODULESPATH . 'main/install/seo.php');
        foreach ($seo as $value) {
            $this->db->delete('seo', array(
                'url' => $value ['url']
            ));
            if (!$russian_exists) {
                unset($value ['title'] ['russian']);
                unset($value ['description'] ['russian']);
                unset($value ['keywords'] ['russian']);
            }
            foreach ($orig_languages as $lang_id => $lang_value) {
                if (!isset($value ['title'] [$lang_value]) && isset($value ['title'] ['english'])) {
                    $value ['title'] [$lang_value] = $value ['title'] ['english'];
                }
                if (!isset($value ['description'] [$lang_value]) && isset($value ['description'] ['english'])) {
                    $value ['description'] [$lang_value] = $value ['description'] ['english'];
                }
                if (!isset($value ['keywords'] [$lang_value]) && isset($value ['keywords'] ['english'])) {
                    $value ['keywords'] [$lang_value] = $value ['keywords'] ['english'];
                }
            }
            $value ['title'] = @serialize($value ['title']);
            $value ['description'] = @serialize($value ['description']);
            $value ['keywords'] = @serialize($value ['keywords']);
            $this->db->insert('seo', $value);
        }
        $this->db->cache_delete_prefix('seo');
    }

    public function install_languages() {
        $languages = array();
        if (file_exists(MODULESPATH . 'main/install/languages.php'))
            @include_once (MODULESPATH . 'main/install/languages.php');
        foreach ($languages as $language) {
            $this->db->delete('languages', array(
                'key' => $language ['key'],
                'module' => $language ['module']
            ));
            $language ['default'] = 1;
            $this->db->insert('languages', $language);
        }
        $languages = array();
        if (file_exists(MODULESPATH . 'main/install/services_languages.php'))
            @include_once (MODULESPATH . 'main/install/services_languages.php');
        foreach ($languages as $language) {
            $this->db->delete('languages', array(
                'key' => $language ['key'],
                'module' => $language ['module']
            ));
            $language ['default'] = 1;
            $this->db->insert('languages', $language);
        }
        $this->db->cache_delete_prefix('languages');
    }

    function install_monetization() {
        $this->load->helper('Monetization');
        if (function_exists('delete_service_template_by_keyword') && function_exists('delete_service_by_keyword')) {
            $templates = array();
            if (file_exists(MODULESPATH . 'main/install/services_templates.php'))
                @include_once(MODULESPATH . 'main/install/services_templates.php');
            foreach ($templates as $template) {
                delete_service_template_by_keyword($template['keyword']);
                save_services_template($template);
            }
            $services = array();
            if (file_exists(MODULESPATH . 'main/install/services.php'))
                @include_once(MODULESPATH . 'main/install/services.php');
            foreach ($services as $service) {
                delete_service_by_keyword($service['keyword']);
                $service['vk_price'] = round((($service['price'] * 30) / 8));
                save_service($service);
            }
            $this->db->cache_delete_prefix('monetization_services');
        }
    }

    function install_menus() {
        $contents = array();
        if (file_exists(MODULESPATH . 'main/install/menus.php'))
            @include_once (MODULESPATH . 'main/install/menus.php');
        foreach ($contents as $content) {
            $this->db->delete('menus', array(
                'id' => $content ['id']
            ));
            $this->db->insert('menus', $content);
        }
        $this->db->cache_delete_prefix('menus');
    }

    public function check_language($language = '') {
        $table_query = $this->db->get('main_pages');
        $fields = $table_query->list_fields();
        if (in_array($language, $fields)) {
            return false;
        }
        $table_query = $this->db->get('main_slider_metro_blocks');
        $fields = $table_query->list_fields();
        if (in_array($language, $fields)) {
            return false;
        }
        $table_query = $this->db->get('main_slider_images');
        $fields = $table_query->list_fields();
        if (in_array($language, $fields)) {
            return false;
        }
        return true;
    }

    public function add_language($language = '', $copy_from) {
        $this->load->dbforge();
        $fields = array(
            $language => array(
                'type' => 'TEXT',
                'default' => '',
                'null' => TRUE
            )
        );
        // Main pages
        if ($this->db->table_exists('main_pages')) {
            $this->dbforge->add_column('main_pages', $fields);
        }
        $this->db->query('UPDATE ' . $this->db->dbprefix('main_pages') . ' set `' . $language . '` = `' . $copy_from . '`');
        // Slider metro
        if ($this->db->table_exists('main_slider_metro_blocks')) {
            $this->dbforge->add_column('main_slider_metro_blocks', $fields);
        }
        $this->db->query('UPDATE ' . $this->db->dbprefix('main_slider_metro_blocks') . ' set `' . $language . '` = `' . $copy_from . '`');
        // Slider images
        if ($this->db->table_exists('main_slider_images')) {
            $this->dbforge->add_column('main_slider_images', $fields);
        }
        $this->db->query('UPDATE ' . $this->db->dbprefix('main_slider_images') . ' set `' . $language . '` = `' . $copy_from . '`');
        $this->db->cache_delete_prefix('main_pages');
        $this->db->cache_delete_prefix('main_slider_metro_blocks');
        $this->db->cache_delete_prefix('main_slider_images');
    }

    public function delete_language($language = '') {
        $this->load->dbforge();
        $this->dbforge->drop_column('main_pages', $language);
        $this->dbforge->drop_column('main_slider_metro_blocks', $language);
        $this->dbforge->drop_column('main_slider_images', $language);
        $this->db->cache_delete_prefix('main_pages');
        $this->db->cache_delete_prefix('main_slider_metro_blocks');
        $this->db->cache_delete_prefix('main_slider_images');
    }

    protected function _install_languages($version = '') {
        $languages = array();
        $this->CI->load->helper('Options');
        $orig_languages = false;
        if (function_exists('load_options')) {
            $orig_languages = load_options('languages');
        }
        if (!$orig_languages) {
            $orig_languages = array(
                'en' => 'english'
            );
        }
        if (file_exists(MODULESPATH . 'main/install/languages_' . $version . '.php'))
            @include_once (MODULESPATH . 'main/install/languages_' . $version . '.php');
        if (is_array($languages) && count($languages) > 0) {
            $russian_exists = true;
            if (!$this->db->field_exists('russian', 'languages')) {
                $russian_exists = false;
            }
            foreach ($languages as $language) {
                $this->db->delete('languages', array(
                    'key' => $language ['key'],
                    'module' => $language ['module']
                ));
                $language ['default'] = 1;
                if (!$russian_exists) {
                    unset($language ['russian']);
                }
                foreach ($orig_languages as $lang_id => $lang_value) {
                    if (!isset($language [$lang_value])) {
                        $language [$lang_value] = $language ['english'];
                    }
                }
                $this->db->insert('languages', $language);
            }
        }
        $this->db->cache_delete_prefix('languages');
    }

    public function install_dynamic_blocks() {
        $this->CI->load->model('Dynamic_blocks_model');
        $this->CI->load->model('Dynamic_blocks_areas_model');
        $this->CI->load->model('Dynamic_blocks_areas_links_model');
        foreach ($this->dynamic_blocks_areas as $area_value) {
            $area = $this->CI->Dynamic_blocks_areas_model->get_area_by_keyword($area_value ['keyword']);
            if (!$area) {
                $area_data = array(
                    'keyword' => $area_value ['keyword'],
                    'name' => $area_value ['name'],
                    'status' => $area_value ['status']
                );
                $this->CI->Dynamic_blocks_areas_model->save_area($area_data);
            }
        }
        foreach ($this->dynamic_blocks as $block_value) {
            $block = $this->CI->Dynamic_blocks_model->get_block_by_keyword($block_value ['keyword']);
            if (!$block) {
                $block_data = array(
                    'name' => $block_value ['name'],
                    'keyword' => $block_value ['keyword'],
                    'module' => $block_value ['module'],
                    'model' => $block_value ['model'],
                    'method' => $block_value ['method'],
                    'params' => $block_value ['params'],
                    'views' => $block_value ['views']
                );
                $block_id = $this->CI->Dynamic_blocks_model->save_block($block_data);
            } else {
                $block_id = $block->id;
            }
            if (!empty($block_value ['area'])) {
                $area = $this->CI->Dynamic_blocks_areas_model->get_area_by_keyword($block_value ['area'] ['keyword']);
                if ($area) {
                    $area = (array) $area;
                    $link = $this->CI->Dynamic_blocks_areas_links_model->get_link_by_area_block_id($area ['id'], $block_id);
                    if (!$link) {
                        $max_item_id = $this->CI->Dynamic_blocks_areas_links_model->get_max_item_id_by_area_id($area ['id']);
                        $link_data = array(
                            'area_id' => $area ['id'],
                            'block_id' => $block_id,
                            'params' => $block_value ['area'] ['params'],
                            'view_string' => $block_value ['area'] ['view_string'],
                            'cache_time' => $block_value ['area'] ['cache_time'],
                            'item_id' => $max_item_id + 1,
                            'status' => 1
                        );
                        $this->CI->Dynamic_blocks_areas_links_model->save_link($link_data);
                    }
                }
            }
        }
    }

    public function install_banners() {
        $sizes = array();
        if (file_exists(MODULESPATH . 'main/install/banners.php'))
            @include_once (MODULESPATH . 'main/install/banners.php');
        if (is_array($sizes) && count($sizes) > 0) {
            $orig_languages = false;
            if (function_exists('load_options')) {
                $orig_languages = load_options('languages');
            }
            if (!$orig_languages || !is_array($orig_languages)) {
                $orig_languages = array(
                    'en' => 'english'
                );
            }
            $russian_exists = true;
            if ($this->db->table_exists('languages') && !$this->db->field_exists('russian', 'languages')) {
                $russian_exists = false;
            }
            $this->load->helper('Themes');
            $user_theme = false;
            $user_theme_id = 0;
            if (function_exists('get_theme_by_keyword') && $this->db->table_exists('themes')) {
                $user_theme = get_theme_by_keyword('user');
                if ($user_theme) {
                    $user_theme_id = $user_theme->id;
                }
            }
            foreach ($sizes as $size) {
                if (!$russian_exists) {
                    unset($size ['russian']);
                }
                foreach ($orig_languages as $lang_id => $lang_value) {
                    if (!isset($size [$lang_value])) {
                        $size [$lang_value] = $size ['english'];
                    }
                }
                $this->db->delete('banners_sizes', array(
                    'keyword' => $size ['keyword']
                ));
                $this->db->insert('banners_sizes', $size);
            }
            $this->db->cache_delete_prefix('banners_sizes');
        }
    }

}
