<div class="span12" id="pages_container">

<ul class="bigBtnIcon">
    <li>
        <a id="add" href="{$site_url}{$lang_code_prefix}admin/main/save_page" class="tipB" title="{l('button_add_page_title','main')}">
            <span class="icon brocco-icon-plus"></span>
            <span class="txt">{l('button_add','main')}</span>
        </a>
    </li>
    <li>
        <a id="delete_selected" href="#" class="tipB" title="{l('button_delete_page_title','main')}">
            <span class="icon icomoon-icon-remove"></span>
            <span class="txt">{l('button_delete','main')}</span>
        </a>
    </li>
</ul>

<div class="box">

    <div class="title">
        <h4>
            <span class="icon16 icomoon-icon-book-2"></span>
            <span>{l('main_pages','main')}</span>
        </h4>
    </div>
    <div class="tab-content" id="list_container">

        {if $pagination}
        {$pagination}
        <br />
        <br />
        {/if}
        <br />

        <form id="delete_form" method="post" action="{$site_url}{$lang_code_prefix}admin/main/delete_page">

            <input type="hidden" name="action" value="delete" />

            <table id="main_pages_table" cellpadding="0" cellspacing="0" border="0" class="responsive table table-bordered" width="100%">
                <thead>
                    <tr>
                        <th><input id="delete_0" type="checkbox" class="grouping_all" /></th>
                        <th class="{if $order == 'date_created'}sorting_{$order_direction}{else}sorting{/if}"><a class="pagination_link" href="{$sort_links.date_created}">{l('field_date_created','main')}</a></th>
                        <th class="{if $order == 'name'}sorting_{$order_direction}{else}sorting{/if}"><a class="pagination_link" href="{$sort_links.name}">{l('field_keyword','main')}</a></th>
                        <th class="{if $order == 'status'}sorting_{$order_direction}{else}sorting{/if}"><a class="pagination_link" href="{$sort_links.status}">{l('field_status','main')}</a></th>
                        <th>{l('actions','main')}</th>
                    </tr>
                </thead>
                <tbody>
                    {if is_array($pages) && count($pages) > 0}
                    {foreach item=item from=$pages}
                    <tr>
                        <td>{if !$item.default}<input id="delete_{$item.id}" name="pages[]" type="checkbox" class="grouping" value="{$item.id}" />{/if}</td>
                        <td>{format_date_str($item.date_created)}</td>
                        <td>{$item.name}</td>
                        <td>{if $item.status}<font class="valid">{l('activated','main')}</font>{else}<font class="error">{l('not_active','main')}</font>{/if}</td>
                        <td>
                            {if !$item.status}
                            <a href="{$site_url}{$lang_code_prefix}admin/main/page_status/{$item.id}/1"><p class="btn btn-mini btn-success"><span class="icon12 entypo-icon-checkmark white"></span>{l('activate','main')}</p></a>
                            {else}
                            <a href="{$site_url}{$lang_code_prefix}admin/main/page_status/{$item.id}/0"><p class="btn btn-mini btn-danger"><span class="icon12 entypo-icon-cancel white"></span>{l('deactivate','main')}</p></a>
                            {/if}
                            <a class="link_edit" href="{$site_url}{$lang_code_prefix}admin/main/save_page/{$item.id}"><p class="btn btn-mini"><span class="icon12 brocco-icon-pencil"></span>{l('button_edit_page','main')}</p></a>
                            {if !$item.default}
                            <a onclick="javascript: if(!confirm('{l('note_delete_page','main')}')) return false;" href="{$site_url}{$lang_code_prefix}admin/main/delete_page/{$item.id}"><p class="btn btn-mini"><span class="icon12 icomoon-icon-remove"></span>{l('button_delete','main')}</p></a>
                            {/if}
                        </td>
                    </tr>
                    {/foreach}
                    {/if}
                </tbody>
                <tfoot>
                    <tr>
                        <th></th>
                        <th>{l('field_date_created','main')}</th>
                        <th>{l('field_keyword','main')}</th>
                        <th>{l('field_status','main')}</th>
                        <th>{l('actions','main')}</th>
                    </tr>
                </tfoot>
            </table>

        </form>

        {$pagination}

            <script type="text/javascript">
                {literal}
                function check_selected() {
                    var all_count = $('input.grouping').size();
                    var checked_count = $('input[checked=checked].grouping').size();
                    if (checked_count == all_count) {
                        $('input.grouping_all').attr('checked', 'checked');
                    } else {
                        $('input.grouping_all').removeAttr('checked');
                    }
                    return checked_count;
                }
                $('document').ready(function(){
                    var pages_container = $('#pages_container');
                    $(pages_container).off();
                    $(pages_container).on('click', 'button', function(){
                        var a = $(this).parent();
                        var link = a.attr('href');
                        document.location.href = link;
                        return false;
                    });
                    var wrapper = $('#wrapper');
                    $(wrapper).off();
                    $(wrapper).on('click', '#delete_selected', function(){
                        if (check_selected() == 0) {
                            $.pnotify({
                                title: '{/literal}{l('errors_not_selected_pages_title','main')}{literal}',
                                text: '{/literal}{l('errors_not_selected_pages_content','main')}{literal}',
                                icon: 'picon icon16 entypo-icon-warning white',
                                opacity: 0.95,
                                sticker: false,
                                history: false
                            });
                        } else {
                            $('#delete_form').submit();
                        }
                        return false;
                    });
                    $(pages_container).on('change', 'input.grouping_all', function(){
                        var checked = $(this).is(':checked');
                        if (checked){
                            $('input[type=checkbox]').attr('checked', 'checked');
                        } else{
                            $('input[type=checkbox]').removeAttr('checked');
                        }
                        check_selected();
                        $.uniform.update();
                    });
                    $(pages_container).on('change', 'input.grouping', function(){
                        var checked = $(this).is(':checked');
                        if (checked) {
                            $(this).attr('checked', 'checked');
                        } else {
                            $(this).removeAttr('checked');
                        }
                        check_selected();
                        $.uniform.update();
                    });
                    $(pages_container).on('click', '#add,.link_edit,.pagination_link', function(){
                        href = $(this).attr('href');
                        $("html").addClass("loadstate");
                        $.post(href, function(data){
                            $(content).html(data);
                            after_load();
                            $("html").removeClass("loadstate");
                            if (old_link != href) {
                                history.pushState('', '', href);
                                old_link = href;
                            }
                        }).fail(function() { $("html").removeClass("loadstate"); document.location.href = href; });
                        return false;
                    });
                });
                {/literal}
            </script>

    </div>
</div><!-- End .box -->

</div>